<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:doc="http://softmedica.pl/schema/Raport" xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0" xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0" xmlns:draw="urn:oasis:names:tc:opendocument:xmlns:drawing:1.0" xmlns:fo="urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0" xmlns:number="urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0" xmlns:presentation="urn:oasis:names:tc:opendocument:xmlns:presentation:1.0" xmlns:svg="urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0" xmlns:chart="urn:oasis:names:tc:opendocument:xmlns:chart:1.0" xmlns:dr3d="urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0" xmlns:math="http://www.w3.org/1998/Math/MathML" xmlns:form="urn:oasis:names:tc:opendocument:xmlns:form:1.0" xmlns:script="urn:oasis:names:tc:opendocument:xmlns:script:1.0" xmlns:ooo="http://openoffice.org/2004/office" xmlns:ooow="http://openoffice.org/2004/writer" xmlns:oooc="http://openoffice.org/2004/calc" xmlns:dom="http://www.w3.org/2001/xml-events" xmlns:xforms="http://www.w3.org/2002/xforms" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:rpt="http://openoffice.org/2005/report" xmlns:of="urn:oasis:names:tc:opendocument:xmlns:of:1.2" xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:grddl="http://www.w3.org/2003/g/data-view#" xmlns:tableooo="http://openoffice.org/2009/table" xmlns:field="urn:openoffice:names:experimental:ooo-ms-interop:xmlns:field:1.0" xmlns:formx="urn:openoffice:names:experimental:ooxml-odf-interop:xmlns:form:1.0" office:version="1.2" grddl:transformation="http://docs.oasis-open.org/office/1.2/xslt/odf2rdf.xsl">
    <xsl:variable name="liczba_kolumn">
        <xsl:choose>
            <!-- liczba komórek w wierszu -->
            <xsl:when test="count(/doc:raport/doc:tabela/doc:naglowek/doc:komorka) > 0">
                <xsl:value-of select="count(/doc:raport/doc:tabela/doc:naglowek/doc:komorka)"/>
            </xsl:when>
            <xsl:otherwise>1</xsl:otherwise>
        </xsl:choose>
    </xsl:variable>

    <xsl:variable name="pierwszy_wiersz">13</xsl:variable> <!-- pierwszy wiersz z danymi -->
    
    <xsl:template match="/">
        <office:document-content xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0" xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0" xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0" xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0" xmlns:draw="urn:oasis:names:tc:opendocument:xmlns:drawing:1.0" xmlns:fo="urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0" xmlns:number="urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0" xmlns:presentation="urn:oasis:names:tc:opendocument:xmlns:presentation:1.0" xmlns:svg="urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0" xmlns:chart="urn:oasis:names:tc:opendocument:xmlns:chart:1.0" xmlns:dr3d="urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0" xmlns:math="http://www.w3.org/1998/Math/MathML" xmlns:form="urn:oasis:names:tc:opendocument:xmlns:form:1.0" xmlns:script="urn:oasis:names:tc:opendocument:xmlns:script:1.0" xmlns:ooo="http://openoffice.org/2004/office" xmlns:ooow="http://openoffice.org/2004/writer" xmlns:oooc="http://openoffice.org/2004/calc" xmlns:dom="http://www.w3.org/2001/xml-events" xmlns:xforms="http://www.w3.org/2002/xforms" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:rpt="http://openoffice.org/2005/report" xmlns:of="urn:oasis:names:tc:opendocument:xmlns:of:1.2" xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:grddl="http://www.w3.org/2003/g/data-view#" xmlns:tableooo="http://openoffice.org/2009/table" xmlns:field="urn:openoffice:names:experimental:ooo-ms-interop:xmlns:field:1.0" xmlns:formx="urn:openoffice:names:experimental:ooxml-odf-interop:xmlns:form:1.0" office:version="1.2" grddl:transformation="http://docs.oasis-open.org/office/1.2/xslt/odf2rdf.xsl">
            <office:automatic-styles>                
                <!-- style kolumn -->
                <style:style style:name="co" style:family="table-column">
                    <style:table-column-properties fo:break-before="auto" style:column-width="4.000cm" style:use-optimal-column-width="true"/>
                </style:style>
                
                <style:style style:name="ro" style:family="table-row">
                    <style:table-row-properties style:use-optimal-row-height="true"/>
                </style:style>
                                
                <!-- style komórek -->
                <style:style style:name="ce_header" style:family="table-cell" style:parent-style-name="Default">
                    <style:table-cell-properties style:text-align-source="fix" style:repeat-content="false" style:vertical-align="middle"/>
                    <style:paragraph-properties fo:text-align="start"/>
                </style:style>               
                <style:style style:name="ce_center_border" style:family="table-cell" style:parent-style-name="Default">
                    <style:table-cell-properties style:text-align-source="fix" style:repeat-content="false" fo:border="0.002cm solid #000000" fo:wrap-option="wrap" style:vertical-align="middle"/>
                    <style:paragraph-properties fo:text-align="center"/>
                </style:style>                
                <style:style style:name="ce_table_header" style:family="table-cell" style:parent-style-name="Default">
                    <style:table-cell-properties style:text-align-source="fix" style:repeat-content="false" fo:border="0.002cm solid #000000" fo:wrap-option="wrap" style:vertical-align="middle" fo:background-color="#e6e6ff"/>
                    <style:paragraph-properties fo:text-align="center"/>
                </style:style>                     
                <style:style style:name="ce_center_bold" style:family="table-cell" style:parent-style-name="Default">
                    <style:table-cell-properties style:text-align-source="fix" style:repeat-content="false" fo:wrap-option="wrap" style:vertical-align="middle"/>
                    <style:paragraph-properties fo:text-align="center"/>
                    <style:text-properties fo:font-weight="bold" style:font-weight-asian="bold" style:font-weight-complex="bold"/>
                </style:style>               

            </office:automatic-styles>
            <office:body>
                <office:spreadsheet>
                    <xsl:apply-templates select="doc:raport"/>
                </office:spreadsheet>
            </office:body>
        </office:document-content>
    </xsl:template>
    <!-- =================================================================== -->    
    <xsl:template match="doc:raport">
        <xsl:variable name="nazwa_arkusza">
            <xsl:value-of select="normalize-space(doc:naglowek/doc:nazwa)"/>
        </xsl:variable>
        <table:table table:name="{$nazwa_arkusza}" >
            <!-- formatowanie kolumn-->                                  
            <xsl:for-each select="doc:tabela/doc:naglowek/doc:komorka">               
                <table:table-column table:style-name="co" table:default-cell-style-name="ce_center_border"/>
            </xsl:for-each>            
            <!-- nagłówek tabeli -->
            <xsl:apply-templates select="doc:naglowek"/>
            <!-- dane -->
            <xsl:apply-templates select="doc:tabela"/>            
        </table:table>
    </xsl:template>
    <!-- =================================================================== -->
    <xsl:template match="doc:raport/doc:naglowek" name="naglowek_raportu">
        <table:table-row>
            <table:table-cell table:style-name="ce_header">
                <text:p>
                    <xsl:value-of select="normalize-space(doc:naglowek1)" />
                </text:p>
            </table:table-cell>
        </table:table-row>
        <table:table-row>
            <table:table-cell table:style-name="ce_header">
                <text:p>
                    <xsl:value-of select="normalize-space(doc:naglowek2)" />
                </text:p>
            </table:table-cell>
        </table:table-row>
        <table:table-row>
            <table:table-cell table:style-name="ce_header">
                <text:p>
                    <xsl:value-of select="normalize-space(doc:naglowek3)" />
                </text:p>
            </table:table-cell>
        </table:table-row>
        <table:table-row>
            <table:table-cell table:style-name="ce_header">
                <text:p>
                    <xsl:value-of select="normalize-space(doc:naglowek4)" />
                </text:p>
            </table:table-cell>
        </table:table-row>
        <table:table-row></table:table-row>
        <table:table-row>
            <table:table-cell table:style-name="ce_center_bold" office:value-type="string" table:number-columns-spanned="{$liczba_kolumn}" table:number-rows-spanned="1">
                <text:p>
                    <xsl:value-of select="normalize-space(doc:tytul)" />
                </text:p>
            </table:table-cell>
        </table:table-row>
        <table:table-row></table:table-row>
    </xsl:template>
    <!-- =================================================================== -->
    <xsl:template match="doc:tabela">    
        <xsl:apply-templates select="doc:naglowek"/>
        <xsl:apply-templates select="doc:wiersz"/>       
    </xsl:template>    
    <!-- =================================================================== -->    
    <xsl:template match="doc:tabela/doc:naglowek" name="naglowek_tabeli">
        <table:table-row>
            <xsl:apply-templates select="doc:komorka"/>
        </table:table-row>
    </xsl:template>
    <!-- =================================================================== -->
    <xsl:template match="doc:naglowek/doc:komorka" name="komorka_naglowka">                      
        <table:table-cell table:style-name="ce_table_header" office:value-type="string">
            <text:p>
                <xsl:value-of select="normalize-space(.)" />
            </text:p>
        </table:table-cell>            
    </xsl:template>
    <!-- =================================================================== -->
    <xsl:template match="doc:wiersz">
        <table:table-row table:style-name="ro">
            <xsl:apply-templates select="doc:komorka"/>
        </table:table-row>
    </xsl:template>
    <!-- =================================================================== -->
    <xsl:template match="doc:wiersz/doc:komorka">
        <table:table-cell>
            <text:p>
                <xsl:value-of select="normalize-space(.)" />
            </text:p>
        </table:table-cell>       
    </xsl:template>
    <!-- =================================================================== -->
</xsl:stylesheet>